LogLik_MLE_GARCH_n <- function(params, ret, h1) {
	params <- c(params, h1)
	t <- recursive_filter_GARCH_n(params, ret)
	
	if (any(is.nan(log(t[["lambda"]])))) {
		return(10000000)
	}

	LL <- sum(log(2*pi)/2 + log(t[["lambda"]])/2 + (t[["z"]]^2)/2)

	if ((LL==Inf)||(is.nan(LL))) {
		return(10000000)
	}
	return(LL)
}

fit_GARCH_MLE_n <- function(ret) {
	initialVals = c(omega = 0.9, alp = 0.211, bet = 0.95)
	lower = c(omega = -1.0, alp = 0, bet = 0)
	upper = c(omega = 1.0, alp = 1.0, bet = 1.0)

	c = optim(initialVals, LogLik_MLE_GARCH_n, ret = ret, lower = lower, h1 = var(ret), upper = upper, method = "L-BFGS-B", control = list(factr = 1e10), hessian = T)

	optim_params <- c$par
	names(optim_params) <- c("ω", "α", "β")
	return(list(optim_vals = optim_params, output = c))	
}	