LogLik_n <- function(params, ret, logrv, h1, report = FALSE) {
	params <- c(params, h1)
	sigma <- params[5]
	t <- recursive_filter_n(params, ret, logrv)
	LL <- sum(- log(2*pi) - (t[["u"]]^2)/2 - (t[["z"]]^2)/2 - t[["lambda"]]/2  - log(sigma))
	# print(LL)
	if ((LL==Inf)||(is.nan(LL))) {
		LL <- -10000000
	}
	if (!report) {
		return(- LL)	
	} else {
		return(list( u = sum(- (t[["u"]]^2)/2  - log(sigma)- log(2*pi)/2), rest = sum(- (t[["z"]]^2)/2 - t[["lambda"]]/2 - log(2*pi)/2)))
	}
}

fit_rGARCH_GAS_n <- function(ret, rv, initialVals = c(xi = 0.0, phi = 1, d1 = 0.0, d2 = 0.0, sigma = 1, omega = 0, alpha = 0.211, beta = 0.9)) {
	# initialVals = c(xi = 0.0, phi = 1.0805, d1 = 0.0, d2 = 0.0, sigma = 1, omega = 0, alpha = 0.211, beta = 0.9)
	lower = c(xi = -5, phi = 0.3, d1 = -0.5, d2 = -0.5, sigma = 0.001, omega = -1.0, alpha = 0, beta = 0.8)
	upper = c(xi = 5, phi = 1.2, d1 = 0.5, d2 = 0.5, sigma = 200, omega = 1.0, alpha = 1.0, beta = 0.999)

	c = optim(initialVals, LogLik_n, ret = ret, logrv = log(rv), h1 = log(rv)[1], lower = lower, upper = upper, method = "L-BFGS-B", control = list(maxit = 1000, factr = 10), hessian = T)
	# c = optim(initialVals, LogLik_n, ret = ret, logrv = log(rv), h1 = log(rv)[1], method = "L-BFGS-B", control = list(maxit = 1000, factr = 1e10), hessian = T)
	optim_params <- c$par
	names(optim_params) <- c("ξ", "φ", "d1", "d2", "σ", "ω", "α", "β")
	return(list(optim_vals = optim_params, output = c))	
}