LogLik_MLE_n <- function(params, ret, logrv, h1, report = FALSE) {
	params <- c(params, h1)
	t <- recursive_filter_mle_n(params, ret, logrv)
	return(LogLik_MLE(t, report))
}

# fit_rGARCH_MLE_n <- function(ret, rv, initialVals = c(xi = 0.001, phi = 1, d1 = 0, d2 = 0, delta_1 = 0, delta_2 = 0, omega = 0.001, gam = 0.25, bet = 0.7)) {
	
# 	c = optim(initialVals, LogLik_MLE_n, ret = ret, logrv = log(rv), h1 = log(rv)[1], method = "L-BFGS-B", control = list(maxit = 1000, factr = 1e10, REPORT = 10, pgtol = 0), hessian = T)

# 	optim_params <- c$par
# 	names(optim_params) <- c("ξ", "φ", "d1", "d2", "δ_1", "δ_2", "ω", "γ", "β")
# 	return(list(optim_vals = optim_params, output = c))	
# }

fit_rGARCH_MLE_n <- function(ret, rv, initialVals = c(xi = 0.001, phi = 1, d1 = 0, d2 = 0, omega = 0.001, gam = 0.25, bet = 0.7)) {
	
	c = optim(initialVals, LogLik_MLE_n, ret = ret, logrv = log(rv), h1 = log(rv)[1], method = "L-BFGS-B", control = list(maxit = 1000, factr = 10, pgtol = 0), hessian = T)

	optim_params <- c$par
	names(optim_params) <- c("ξ", "φ", "d1", "d2", "ω", "γ", "β")
	return(list(optim_vals = optim_params, output = c))	
}