LogLik_multiple <- function(params, rets, rvs, h1, report = FALSE) {
	params <- c(params, h1)
	t <- recursive_filter_multi(params, rets, rvs)
	return(LogLik_MLE(t, report))
}

fit_rGARCH_multiple <- function(ret, rv, initialVals = c(0.04, 0.98, 0, 0, rep(0.1, k), rep(c(0, 0.9, 0, 0), k))) {
	k <- ncol(rv)

	upper = c(2, 1, 0.1, 0.1, rep(0.5, k), rep(c(2, 1.6, 0.5, 0.5), k))
	lower = c(0, 0, -0.1, -0.1, rep(-0.5, k), rep(c(-4, 0, -0.5, -0.5), k))
	c <- optim(initialVals, LogLik_multiple, rets = ret, rvs = as.matrix(rv), h1 = log(as.matrix(rv)[1,1]), method = "L-BFGS-B", control = list(maxit = 1000, factr = 10, pgtol = 0), hessian = T, upper = upper, lower = lower)	
	optim_params <- c$par

	λ <- c(optim_params[1:(4+k)])
	names(λ) <- c("ω", "β", "d1", "d2", paste("γ", colnames(rv), sep="_"))
	ψ <- matrix(optim_params[(5+k):(length(optim_params))], ncol = k)
	ψ <- t(ψ)
	rownames(ψ) <- colnames(rv)
	colnames(ψ) <- c("ξ", "φ", paste("δ", 1:2, sep="_"))
	
	return(list(optim_vals = λ, rv_params = ψ, output = c))	
}